Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim x As Integer
        Dim y As Double
        Dim dr As DataRow
        Dim dc As DataColumn
        Dim dt As New DataTable("Test")
        Dim maxcols As Integer = 3
        Dim maxrows As Integer = 100
        For j As Integer = 0 To maxcols - 1
            dc = New DataColumn
            dc.ColumnName = "Test" & j
            If j = 1 Or j = 2 Then
                dc.DataType = Type.GetType("System.Double")
            Else
                dc.DataType = Type.GetType("System.Int32")
            End If
            dt.Columns.Add(dc)
        Next
        Randomize()
        For i As Integer = 0 To maxrows - 1
            dr = dt.NewRow
            x = Int((49 * Rnd()) + 1)
            y = CType(Rnd(), Double)
            For j As Integer = 0 To maxcols - 1
                If j = 1 Or j = 2 Then
                    dr.Item(j) = y
                Else
                    dr.Item(j) = x.ToString
                End If
            Next
            dt.Rows.Add(dr)
        Next
        FpSpread1.DataSource = dt
        FpSpread1.Sheets(0).Columns(0).AllowAutoFilter = True
        FpSpread1.Sheets(0).AddUnboundRows(FpSpread1.Sheets(0).RowCount, 1)
        FpSpread1.Sheets(0).Cells(FpSpread1.Sheets(0).RowCount - 1, 1).Formula = "SUM(B1:B" & FpSpread1.Sheets(0).RowCount - 1 & ")"
        FpSpread1.AllowUserFormulas = True
    End Sub

    Private Sub FpSpread1_AutoFilteredColumn(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.AutoFilteredColumnEventArgs) Handles FpSpread1.AutoFilteredColumn
        If e.FilterString <> "(All)" Then
            'Put totals row into filtered list
            FpSpread1.Sheets(0).Cells(FpSpread1.Sheets(0).RowCount - 1, 0).Value = e.FilterString
            'Reset the formuls
            FpSpread1.Sheets(0).Cells(FpSpread1.Sheets(0).RowCount - 1, 1).Formula = "SUMIF(A1:A" & FpSpread1.Sheets(0).RowCount - 1 & ",""=" & e.FilterString & """,B1:B" & FpSpread1.Sheets(0).RowCount - 1 & ")"
        Else
            'Put totals row into filtered list
            FpSpread1.Sheets(0).Cells(FpSpread1.Sheets(0).RowCount - 1, 0).Value = Nothing
            'Reset the formuls
            FpSpread1.Sheets(0).Cells(FpSpread1.Sheets(0).RowCount - 1, 1).Formula = "SUM(B1:B" & FpSpread1.Sheets(0).RowCount - 1 & ")"
        End If
    End Sub
End Class
